// BonClassEnumerator.cpp: BonNX񋓃NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "BonClassEnumerator.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// BonNX񋓃NX
/////////////////////////////////////////////////////////////////////////////

const DWORD CBonClassEnumerator::EnumBonClass(LPCTSTR lpszBIId)
{
	if(!lpszBIId)return 0UL;
	if(!lpszBIId[0])return 0UL;

	// XgNA
	ReleaseCatalog();

	// C^tF[Xۑ
	::_tcscpy(m_szEnumBIId, lpszBIId);

	// RAGWCX^X擾
	IBonCoreEngine *pCoreEngine = dynamic_cast<IBonCoreEngine *>(::GET_STOCK_INSTANCE(TEXT("CBonCoreEngine")));
	::BON_ASSERT(pCoreEngine != NULL);

	DWORD dwModIndex = 0UL;
	TCHAR szModName[BON_MAX_MODULE_NAME] = TEXT("");
	
	// W[
	while(pCoreEngine->GetBonModuleName(pCoreEngine->EnumBonModule(dwModIndex++), szModName)){
		// W[J^OCX^X
		IBonModCatalog *pModCatalog = ::BON_SAFE_CREATE<IBonModCatalog *>(szModName);

		// Xgɒǉ
		if(pModCatalog)m_CatalogList.push_back(pModCatalog);
		}

	// NX
	for(dwModIndex = 0UL ; dwModIndex < m_CatalogList.size() ; dwModIndex++){
		DWORD dwClassIndex = 0UL;
		
		while(m_CatalogList[dwModIndex]->EnumClass(lpszBIId, dwClassIndex) != BCID_NULL){
			// NXXgɒǉ
			CLASS_CAT_INFO NewInfo = {m_CatalogList[dwModIndex], dwClassIndex++};
			m_ClassList.push_back(NewInfo);
			}
		}

	// w肳ꂽC^tF[X̃NXԂ
	return m_ClassList.size();
}

const DWORD CBonClassEnumerator::GetBonClassNum(void)
{
	// 񋓂ꂽNXԂ
	return m_ClassList.size();
}

const DWORD CBonClassEnumerator::GetBonModuleName(DWORD dwIndex, LPTSTR lpszModuleName)
{
	// W[Ԃ
	return (dwIndex < m_ClassList.size())? ::GET_BON_CLASS_NAME(m_ClassList[dwIndex].pModCatalog->GetGuid(), lpszModuleName) : 0UL;
}

const DWORD CBonClassEnumerator::GetBonClassName(DWORD dwIndex, LPTSTR lpszClassName)
{
	// NXԂ
	return (dwIndex < m_ClassList.size())? ::GET_BON_CLASS_NAME(m_ClassList[dwIndex].pModCatalog->EnumClass(m_szEnumBIId, m_ClassList[dwIndex].dwClassIndex), lpszClassName) : 0UL;
}

const DWORD CBonClassEnumerator::GetBonClassDesc(DWORD dwIndex, LPTSTR lpszDescription)
{
	// NX̐Ԃ
	return (dwIndex < m_ClassList.size())? m_ClassList[dwIndex].pModCatalog->GetClassDesc(m_ClassList[dwIndex].pModCatalog->EnumClass(m_szEnumBIId, m_ClassList[dwIndex].dwClassIndex), lpszDescription) : 0UL;
}

const DWORD CBonClassEnumerator::GetBonModuleComment(DWORD dwIndex, LPTSTR lpszComment)
{
	// W[̐Ԃ
	return (dwIndex < m_ClassList.size())? m_ClassList[dwIndex].pModCatalog->GetComment(lpszComment) : 0UL;
}

const DWORD CBonClassEnumerator::GetBonModuleAuthor(DWORD dwIndex, LPTSTR lpszAuthor)
{
	// W[̍ҖԂ
	return (dwIndex < m_ClassList.size())? m_ClassList[dwIndex].pModCatalog->GetAuthor(lpszAuthor) : 0UL;
}

const DWORD CBonClassEnumerator::GetBonModuleWebsite(DWORD dwIndex, LPTSTR lpszWebsite)
{
	// W[̘AԂ
	return (dwIndex < m_ClassList.size())? m_ClassList[dwIndex].pModCatalog->GetWebsite(lpszWebsite) : 0UL;
}

CBonClassEnumerator::CBonClassEnumerator(IBonObject *pOwner)
	: CBonObject(pOwner)
{
	// Ȃ
}

CBonClassEnumerator::~CBonClassEnumerator(void)
{
	// J^OCX^XJ
	ReleaseCatalog();
}

void CBonClassEnumerator::ReleaseCatalog(void)
{
	// C^tF[XNA
	m_szEnumBIId[0] = TEXT('\0');

	// NXXgNA
	m_ClassList.clear();
	
	// J^OCX^XJ
	for(DWORD dwIndex = 0UL ; dwIndex < m_CatalogList.size() ; dwIndex++){
		m_CatalogList[dwIndex]->Release();
		}

	m_CatalogList.clear();
}
