// IniCfgStorage.cpp: ėpRtBM[VXg[WNX(INIt@C)
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include <StdLib.h>
#include "TChar.h"
#include "IniCfgStorage.h"


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// ftHg̃ZNV
#define ROOT_SECTNAME		TEXT("General")		// [General]

#define MAX_SECTNAME_LEN	256UL				// őZNV
#define MAX_SECTNAME_NUM	256UL				// őZNV
#define MAX_VALNAME_LEN		256UL				// őACe
#define MAX_VALNAME_NUM		256UL				// őACe
#define MAX_TEXTVAL_LEN		65536UL				// őeLXgACe


/////////////////////////////////////////////////////////////////////////////
// ėpRtBM[VXg[WNX(INIt@C)
/////////////////////////////////////////////////////////////////////////////

const bool CIniCfgStorage::OpenStorage(LPCTSTR lpszPathName, const bool bCreate)
{
	// UN[Y
	CloseStorage();

	// st@C̃pX擾
	TCHAR szDrive[_MAX_DRIVE + 1] = TEXT("\0");
	TCHAR szDir[_MAX_DIR + 1]	  = TEXT("\0");
	TCHAR szFile[_MAX_FNAME + 1]  = TEXT("\0");

	if(!::GetModuleFileName(NULL, m_szFileName, sizeof(m_szFileName) - 1))return false;
	::_tsplitpath(m_szFileName, szDrive, szDir, szFile, NULL);
	::_tmakepath(m_szFileName, szDrive, szDir, szFile, TEXT("ini"));	

	// ZNVݒ
	::_tcscpy(m_szSectName, (lpszPathName)? lpszPathName : ROOT_SECTNAME);

	// ZNV݂̑`FbN
	if(!bCreate){
		if(!IsSectionExist(m_szSectName)){
			// ZNVȂ
			CloseStorage();
			return false;
			}
		}

	return true;
}

const bool CIniCfgStorage::CloseStorage(void)
{
	// t@CAZNVNA
	m_szFileName[0] = TEXT('\0');
	m_szSectName[0] = TEXT('\0');

	return true;
}

IConfigStorage * CIniCfgStorage::OpenSection(LPCTSTR lpszSection, const bool bCreate)
{
	if(!m_szFileName[0] || !lpszSection)return NULL;

	// ZNV݂̑`FbN
	if(!bCreate){
		// 쐬[hłȂƂ̓ZNVȂ΃G[
		if(!IsSectionExist(lpszSection))return NULL;
		}

	// VCX^X
	CIniCfgStorage *pNewInstance = new CIniCfgStorage(NULL);
	if(!pNewInstance)return NULL;
		
	// t@Cݒ
	::_tcscpy(pNewInstance->m_szFileName, m_szFileName);

	// VCX^XɃZNVݒ
	GetSectionPath(pNewInstance->m_szSectName, lpszSection);
		
	return pNewInstance;
}

const DWORD CIniCfgStorage::GetSectionNum(void)
{
	if(!m_szFileName[0])return false;

	// ZNV񋓂
	TCHAR szSections[MAX_SECTNAME_LEN * MAX_SECTNAME_NUM] = TEXT("\0");

	const DWORD dwRet = ::GetPrivateProfileSectionNames(szSections, sizeof(szSections) / sizeof(szSections[0]), m_szFileName);
	if(!dwRet || ((dwRet + 2UL) == (sizeof(szSections) / sizeof(szSections[0]))))return false;

	// ZNVJEg
	DWORD dwSectNum = 0UL;
	LPCTSTR lpszFindPos = szSections;

	while(*lpszFindPos){
		// ZNVCNg
		if(IsSubSectionPath(lpszFindPos))dwSectNum++;
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	return dwSectNum;
}

const DWORD CIniCfgStorage::EnumSection(const DWORD dwIndex, LPTSTR lpszSection)
{
	if(!m_szFileName[0])return 0UL;

	// ZNV񋓂
	TCHAR szSections[MAX_SECTNAME_LEN * MAX_SECTNAME_NUM] = TEXT("\0");

	const DWORD dwRet = ::GetPrivateProfileSectionNames(szSections, sizeof(szSections) / sizeof(szSections[0]), m_szFileName);
	if(!dwRet || ((dwRet + 2UL) == (sizeof(szSections) / sizeof(szSections[0]))))return 0UL;

	// ZNVJEg
	DWORD dwSectNum = 0UL;
	LPCTSTR lpszFindPos = szSections;

	while(*lpszFindPos){
		// ZNVCNg
		if(IsSubSectionPath(lpszFindPos)){
			if(dwSectNum == dwIndex){
				// CfbNXv
				if(lpszSection)::_tcscpy(lpszSection, lpszFindPos);
				return ::_tcslen(lpszFindPos);
				}

			dwSectNum++;
			}
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	return 0UL;
}

const bool CIniCfgStorage::DeleteSection(LPCTSTR lpszSection)
{
	if(!m_szFileName[0] || !lpszSection)return false;

	// ZNV݂̑`FbN
	if(!IsSectionExist(lpszSection))return false;

	// ZNVpX
	TCHAR szPath[MAX_SECTNAME_NUM];
	GetSectionPath(szPath, lpszSection);

	// ZNV폜
	return (::WritePrivateProfileSection(szPath, NULL, m_szFileName))? true : false;
}

const DWORD CIniCfgStorage::GetItemNum(void)
{
	if(!m_szFileName[0])return 0UL;

	// ACe񋓂
	TCHAR szItems[MAX_VALNAME_LEN * MAX_VALNAME_NUM] = TEXT("\0");
	const DWORD dwRet = ::GetPrivateProfileString(m_szSectName, NULL, NULL, szItems, sizeof(szItems) / sizeof(szItems[0]), m_szFileName);

	if(!dwRet || ((dwRet + 2UL) == (sizeof(szItems) / sizeof(szItems[0]))))return 0UL;

	// ACeJEg
	DWORD dwItemNum = 0UL;
	LPCTSTR lpszFindPos = szItems;

	while(*lpszFindPos){
		// ACeCNg
		dwItemNum++;
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	// ACeԂ
	return dwItemNum;
}

const DWORD CIniCfgStorage::EnumItem(const DWORD dwIndex, LPTSTR lpszItem)
{
	if(!m_szFileName[0])return 0UL;

	// ACe񋓂
	TCHAR szItems[MAX_VALNAME_LEN * MAX_VALNAME_NUM] = TEXT("\0");
	const DWORD dwRet = ::GetPrivateProfileString(m_szSectName, NULL, NULL, szItems, sizeof(szItems) / sizeof(szItems[0]), m_szFileName);

	if(!dwRet || ((dwRet + 2UL) == (sizeof(szItems) / sizeof(szItems[0]))))return 0UL;

	// ACeJEg
	DWORD dwItemNum = 0UL;
	LPTSTR lpszFindPos = szItems;

	while(*lpszFindPos){
		// ACeCNg
		if(dwItemNum == dwIndex){
			// CfbNXv
			if(lpszItem)::_tcscpy(lpszItem, lpszFindPos);
			return ::_tcslen(lpszFindPos);
			}		
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		dwItemNum++;
		}

	return 0UL;
}

const DWORD CIniCfgStorage::GetItemType(LPCTSTR lpszItem)
{
	if(!m_szFileName[0] || !lpszItem)return ITEM_TYPE_INVALID;

	// ACe^CvԂ(INIt@C̏ꍇ͏ɃeLXg)
	return (IsItemExist(lpszItem))? ITEM_TYPE_TEXT : ITEM_TYPE_INVALID;
}

const bool CIniCfgStorage::DeleteItem(LPCTSTR lpszItem)
{
	if(!m_szFileName[0] || !lpszItem)return false;

	// ACe폜
	return (::WritePrivateProfileString(m_szSectName, lpszItem, NULL, m_szFileName))? true : false;
}

const bool CIniCfgStorage::SetBoolItem(LPCTSTR lpszItem, const bool bValue)
{
	if(!m_szFileName[0] || !lpszItem)return false;
	
	// BOOLZ[u
	return (::WritePrivateProfileString(m_szSectName, lpszItem, (bValue)? TEXT("1") : TEXT("0"), m_szFileName))? true : false;
}

const bool CIniCfgStorage::SetIntItem(LPCTSTR lpszItem, const DWORD dwValue)
{
	if(!m_szFileName[0] || !lpszItem)return false;

	TCHAR szValue[16];
	::_stprintf(szValue, TEXT("%lu"), dwValue);

	// DWORDZ[u
	return (::WritePrivateProfileString(m_szSectName, lpszItem, szValue, m_szFileName))? true : false;
}

const bool CIniCfgStorage::SetTextItem(LPCTSTR lpszItem, LPCTSTR lpszValue)
{
	if(!m_szFileName[0] || !lpszItem || !lpszValue)return false;

	// Z[u
	return (::WritePrivateProfileString(m_szSectName, lpszItem, lpszValue, m_szFileName))? true : false;
}

const bool CIniCfgStorage::GetBoolItem(LPCTSTR lpszItem, const bool bDefault)
{
	if(!m_szFileName[0] || !lpszItem)return false;

	// BOOL[h
	return (::GetPrivateProfileInt(m_szSectName, lpszItem, (bDefault)? 1UL : 0UL, m_szFileName))? true : false;
}

const DWORD CIniCfgStorage::GetIntItem(LPCTSTR lpszItem, const DWORD dwDefault, const DWORD dwMax, const DWORD dwMin)
{
	if(!m_szFileName[0] || !lpszItem)return false;

	// DWORD[h
	const DWORD dwValue = (DWORD)::GetPrivateProfileInt(m_szSectName, lpszItem, dwDefault, m_szFileName);
	
	// ͈͂`FbN
	return ((dwValue >= dwMin) && (dwValue <= dwMax))? dwValue : dwDefault;
}

const DWORD CIniCfgStorage::GetTextItem(LPCTSTR lpszItem, LPTSTR lpszValue, LPCTSTR lpszDefault, const DWORD dwMaxLen)
{
	if(!m_szFileName[0] || !lpszItem)return false;

	TCHAR szValue[MAX_TEXTVAL_LEN] = TEXT("\0");
	if(lpszDefault)::_tcscpy(szValue, lpszDefault);

	// [h
	const DWORD dwRet = ::GetPrivateProfileString(m_szSectName, lpszItem, (lpszDefault)? lpszDefault : TEXT(""), szValue, sizeof(szValue) / sizeof(szValue[0]), m_szFileName);

	// `FbN
	if(dwRet > dwMaxLen){
		::_tcscpy(szValue, (lpszDefault)? lpszDefault : TEXT(""));
		}
		
	// obt@ɃRs[
	if(lpszValue)::_tcscpy(lpszValue, szValue);
	
	// Ԃ
	return ::_tcslen(szValue);
}

CIniCfgStorage::CIniCfgStorage(IBonObject *pOwner)
	: CBonObject(pOwner)
{
	m_szFileName[0] = TEXT('\0');
	m_szSectName[0] = TEXT('\0');
}

CIniCfgStorage::~CIniCfgStorage(void)
{
	// Xg[WN[Y
	CloseStorage();
}

void CIniCfgStorage::GetSectionPath(LPTSTR lpszPath, LPCTSTR lpszSection) const
{
	if(!m_szFileName[0] || !lpszPath || !lpszSection)::DebugBreak();

	// ZNVpX𐶐
	if(!::_tcscmp(m_szSectName, ROOT_SECTNAME)){
		// [g
		::_tcscpy(lpszPath, lpszSection);
		}
	else{
		// TuZNVȉ
		::_stprintf(lpszPath, TEXT("%s\\%s"), m_szSectName, lpszSection);
		}
}

const bool CIniCfgStorage::IsSectionExist(LPCTSTR lpszSection) const
{
	if(!m_szFileName[0] || !lpszSection)::DebugBreak();

	// ZNV񋓂
	TCHAR szSections[MAX_SECTNAME_LEN * MAX_SECTNAME_NUM] = TEXT("\0");

	const DWORD dwRet = ::GetPrivateProfileSectionNames(szSections, sizeof(szSections) / sizeof(szSections[0]), m_szFileName);
	if(!dwRet || ((dwRet + 2UL) == (sizeof(szSections) / sizeof(szSections[0]))))return false;

	// ZNV
	TCHAR szFindSection[MAX_SECTNAME_NUM];

	if(!::_tcscmp(m_szSectName, ROOT_SECTNAME)){
		// [g
		::_tcscpy(szFindSection, lpszSection);
		}
	else{
		// TuZNVȉ
		::_stprintf(szFindSection, TEXT("%s\\%s"), m_szSectName, lpszSection);
		}

	// ZNV
	LPCTSTR lpszFindPos = szSections;

	while(*lpszFindPos){
		if(!::_tcscmp(lpszFindPos, szFindSection)){
			// ZNVv
			return true;
			}
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	return false;
}

const bool CIniCfgStorage::IsSubSectionPath(LPCTSTR lpszPath) const
{
	if(!m_szFileName[0] || !lpszPath)::DebugBreak();

	if(!::_tcscmp(m_szSectName, ROOT_SECTNAME)){
		// [g
		if(!::_tcschr(lpszPath, TEXT('\\')))return true;
		}
	else{
		// TuZNVȉ
		const DWORD dwParentLen = ::_tcslen(m_szSectName) + 1UL;

		if((DWORD)::_tcslen(lpszPath) > dwParentLen){
			// eZNV蒷
			if(!::_tcsnicmp(lpszPath, m_szSectName, dwParentLen)){
				// ZNVŎn܂					
				if(!::_tcschr(&lpszPath[dwParentLen], TEXT('\\')))return true;
				}
			}
		}

	return false;
}

const bool CIniCfgStorage::IsItemExist(LPCTSTR lpszItem) const
{
	if(!m_szFileName[0] || !lpszItem)::DebugBreak();

	// ACe񋓂
	TCHAR szItems[MAX_VALNAME_LEN * MAX_VALNAME_NUM] = TEXT("\0");
	const DWORD dwRet = ::GetPrivateProfileString(m_szSectName, NULL, NULL, szItems, sizeof(szItems) / sizeof(szItems[0]), m_szFileName);

	if(!dwRet || ((dwRet + 2UL) == (sizeof(szItems) / sizeof(szItems[0]))))return false;

	// ACe
	LPCTSTR lpszFindPos = szItems;

	while(*lpszFindPos){
		if(!::_tcsicmp(lpszFindPos, lpszItem))return true;
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	return false;
}
