// SyncObject.h: IuWFNgbp[NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// NeBJZNVbp[NX
/////////////////////////////////////////////////////////////////////////////

class CSmartLock
{
public:
	CSmartLock();
	virtual ~CSmartLock();
	
	void Lock(void);
	void Unlock(void);
	
protected:
	CRITICAL_SECTION m_CriticalSection;
};


/////////////////////////////////////////////////////////////////////////////
// ubNXR[vbNNX
/////////////////////////////////////////////////////////////////////////////

class CBlockLock
{
public:
	CBlockLock(CSmartLock *pSmartLock);
	virtual ~CBlockLock();
		
protected:
	CSmartLock *m_pSmartLock;
};


/////////////////////////////////////////////////////////////////////////////
// J[lIuWFNgNX
/////////////////////////////////////////////////////////////////////////////

class CKernelObject : public IKernelObject
{
public:
	virtual ~CKernelObject();

	const bool IsAssigned() const;
	const HANDLE UnsafeGetHandle() const;

	operator const bool() const;
	const bool operator !() const;

	CWaitAnyObjects operator ||(const IKernelObject &rhs) const;
	CWaitAnyObjects operator ||(const IKernelObject *pRhs) const;
	CWaitAllObjects operator &&(const IKernelObject &rhs) const;
	CWaitAllObjects operator &&(const IKernelObject *pRhs) const;

	const WaitResult Wait(const DWORD dwTimeout = INFINITE) const;

protected:
	CKernelObject(HANDLE handle = NULL, HANDLE invalid = NULL);
	void Assign(HANDLE handle);
	const bool Close();

private:
	HANDLE m_Invalid;
	HANDLE m_Handle;

	CKernelObject(const CKernelObject &);
	void operator =(const CKernelObject &);
};


/////////////////////////////////////////////////////////////////////////////
// Cxgbp[NX
/////////////////////////////////////////////////////////////////////////////

class CSmartEvent : public CKernelObject
{
public:
	CSmartEvent(const bool bManualReset = false, const bool bInitialState = false);
	const bool Close(void);

	const bool SetEvent(void);
	const bool PulseEvent(void);
	const bool ResetEvent(void);
};


/////////////////////////////////////////////////////////////////////////////
// ~[ebNXbp[NX
/////////////////////////////////////////////////////////////////////////////

class CSmartMutex : public CKernelObject
{
public:
	CSmartMutex(void);

	const bool Create(LPCTSTR lpszName);
	const bool Close(void);

	static const bool IsExist(LPCTSTR lpszName);
};

}
