// BonBlackTuner.cpp: Friio`[i[NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Resource.h"
#include "BonSDK.h"
#include "BonBlackTuner.h"
#include <Math.h>
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// foCX
#define DEVICENAME	TEXT(" Friio USB 2.0 Digital TV Receiver")

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020UL	// `[iRg[
#define IOCODE_STREAM		0x0022004BUL	// Xg[NGXg

// LNBLWXg
#define ENABLE_LNB_REGKEY	TEXT("Software\\BonSDK\\FriioDriver")
#define ENABLE_LNB_REGNAME	TEXT("EnableLnbFunction")
#define ENABLE_LNB_REGVALUE	1


/////////////////////////////////////////////////////////////////////////////
// Friiop@TS`[i HALC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CBonBlackTuner::GetDeviceName(LPTSTR lpszName)
{
	// foCXԂ
	if(lpszName)::_tcscpy(lpszName, DEVICENAME);

	return ::_tcslen(DEVICENAME);
}

const bool CBonBlackTuner::OnOpenTuner(void)
{
	try
	{
		// hCo
		if(!m_BonEnumerator.EnumDevice(true))throw __LINE__;
	}
	catch (...)
	{
		// G[
		return false;
	}

	return true;
}

const DWORD CBonBlackTuner::EnumTuningSpace(const DWORD dwSpace, LPTSTR lpszSpace)
{
	static const TCHAR aszTuningSpace[][16] = 
	{
		TEXT("BS"	),
		TEXT("110CS")
	};

	// gp\ȃ`[jOԂԂ
	if(dwSpace >= (sizeof(aszTuningSpace) / sizeof(aszTuningSpace[0])))return 0UL;

	// `[jOԖRs[
	if(lpszSpace)::_tcscpy(lpszSpace, aszTuningSpace[dwSpace]);

	// `[jOԖԂ
	return ::_tcslen(aszTuningSpace[dwSpace]);
}

const DWORD CBonBlackTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel, LPTSTR lpszChannel)
{
	// gp\ȃ`lԂ
	static const TCHAR aszChannelNameBS[][32] = 
	{
		TEXT("BS1/TS0 BS"			),
		TEXT("BS1/TS1 BS-i"				),
		TEXT("BS3/TS0 WOWOW"			),
		TEXT("BS3/TS1 BSWp"		),
		TEXT("BS9/TS0 BS11"				),
		TEXT("BS9/TS1 Star Channel HV"	),
		TEXT("BS9/TS2 TwellV"			),
		TEXT("BS13/TS0 BSe"		),
		TEXT("BS13/TS1 BStW"			),
		TEXT("BS15/TS1 NHK BS1/2"		),
		TEXT("BS15/TS2 NHK BS-hi"		)
	};

	static const TCHAR aszChannelNameCS[][32] = 
	{
		TEXT("ND2 110CS #1"  ),
		TEXT("ND4 110CS #2"  ),
		TEXT("ND6 110CS #3"  ),
		TEXT("ND8 110CS #4"  ),
		TEXT("ND10 110CS #5" ),
		TEXT("ND12 110CS #6" ),
		TEXT("ND14 110CS #7" ),
		TEXT("ND16 110CS #8" ),
		TEXT("ND18 110CS #9" ),
		TEXT("ND20 110CS #10"),
		TEXT("ND22 110CS #11"),
		TEXT("ND24 110CS #12")
	};

	switch(dwSpace){
		case 0UL :
			// BS
			if(dwChannel >= (sizeof(aszChannelNameBS) / sizeof(aszChannelNameBS[0])))return 0UL;

			// `lRs[
			if(lpszChannel)::_tcscpy(lpszChannel, aszChannelNameBS[dwChannel]);

			// `lԂ
			return ::_tcslen(aszChannelNameBS[dwSpace]);

		case 1UL :
			// 110CS
			if(dwChannel >= (sizeof(aszChannelNameCS) / sizeof(aszChannelNameCS[0])))return 0UL;

			// `lRs[
			if(lpszChannel)::_tcscpy(lpszChannel, aszChannelNameCS[dwChannel]);

			// `lԂ
			return ::_tcslen(aszChannelNameCS[dwSpace]);

		default  :
			// Ή̃`[jO
			return 0UL;
	}
}

const bool CBonBlackTuner::OnSetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// `[jOV[PXϕ
	static const BYTE abyPllConfA[] = {0x08U, 0x08U, 0x08U, 0x08U, 0x09U, 0x09U, 0x09U, 0x0AU, 0x0AU, 0x0AU, 0x0AU, 0x0CU, 0x0CU, 0x0DU, 0x0DU, 0x0DU, 0x0EU, 0x0EU, 0x0EU, 0x0FU, 0x0FU, 0x0FU, 0x10U};	// 1/17 +40
	static const BYTE abyPllConfB[] = {0x32U, 0x32U, 0x80U, 0x80U, 0x64U, 0x64U, 0x64U, 0x00U, 0x00U, 0x4CU, 0x4CU, 0x9AU, 0xEAU, 0x3AU, 0x8AU, 0xDAU, 0x2AU, 0x7AU, 0xCAU, 0x1AU, 0x6AU, 0xBAU, 0x0AU};	// 2/18 +40
	static const BYTE abyPllConfC[] = {0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U};	// 75	+02
	static const BYTE abyPllConfD[] = {0x10U, 0x11U, 0x30U, 0x31U, 0x90U, 0x91U, 0x92U, 0xD0U, 0xD1U, 0xF1U, 0xF2U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U};	// 76	+02

	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(GetModuleInstance(), MAKEINTRESOURCE(IDR_CHSEQ_BLACK), TEXT("BINARY"));
	if(!hRsrc)return false;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(GetModuleInstance(), hRsrc);
	if(!hGlobal)return false;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return false;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(GetModuleInstance(), hRsrc);

	// \[Xf[^𑗐M
	const DWORD dwChIndex = dwSpace * 11UL + dwChannel;
	DWORD dwXmitNum = 0UL;
	DWORD dwXmited = 0UL;
	FIXED_REQ_HEAD *pFixedReqHead;

	while(dwXmited < dwIoReqSize)
	{
		// Rg[擾
		pFixedReqHead = (FIXED_REQ_HEAD *)pFixedBuff;
		pFixedBuff += sizeof(FIXED_REQ_HEAD);

		// Mobt@NA
		BYTE RxdBuff[256];
		::ZeroMemory(RxdBuff, sizeof RxdBuff);

		// Mf[^
		BYTE TxdBuff[256];
		::ZeroMemory(TxdBuff, sizeof TxdBuff);
		::CopyMemory(TxdBuff, pFixedBuff, pFixedReqHead->wTxdSize);

		switch(dwXmitNum++){
			case 0UL  :	TxdBuff[40] = abyPllConfA[dwChIndex];	break;
			case 1UL  :	TxdBuff[40] = abyPllConfB[dwChIndex];	break;
			case 16UL :	TxdBuff[40] = abyPllConfA[dwChIndex];	break;
			case 17UL :	TxdBuff[40] = abyPllConfB[dwChIndex];	break;
			case 74UL :	TxdBuff[ 2] = abyPllConfC[dwChIndex];	break;
			case 75UL :	TxdBuff[ 2] = abyPllConfD[dwChIndex];	break;
		}

		// f[^M
		if(SendIoRequest(pFixedReqHead->dwIoCode, TxdBuff, pFixedReqHead->wTxdSize, RxdBuff, pFixedReqHead->wRxdSize) == -1)return false;
		pFixedBuff += pFixedReqHead->wTxdSize;

		// MσTCYXV
		dwXmited += (sizeof(FIXED_REQ_HEAD) + pFixedReqHead->wTxdSize);
	}

	return true;
}

const bool CBonBlackTuner::SetLnbPower(const bool bEnable)
{
	static const BYTE SetLnbReq[][0x26] =
	{
		{ 0x40, 0x01 ,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
		{ 0x40, 0x01 ,0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	};

	// #### ߓdی@\̂ȂFriioł͏đ̉\邽߁AWXgɃtOĂꍇ ###
	HKEY hKey = 0;
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, ENABLE_LNB_REGKEY, 0, KEY_READ, &hKey) != ERROR_SUCCESS)
	{
		return false;
	}
	DWORD type = REG_NONE;
	if(RegQueryValueEx(hKey, ENABLE_LNB_REGNAME, 0, &type, 0, 0) != ERROR_SUCCESS)
	{
		RegCloseKey(hKey);
		return false;
	}
	if (type != REG_DWORD)
	{
		RegCloseKey(hKey);
		return false;
	}
	DWORD value = 0, size = sizeof value;
	if(RegQueryValueEx(hKey, ENABLE_LNB_REGNAME, 0, 0, reinterpret_cast<LPBYTE>(&value), &size) != ERROR_SUCCESS)
	{
		RegCloseKey(hKey);
		return false;
	}
	RegCloseKey(hKey);
	if (value != ENABLE_LNB_REGVALUE)
	{
		return false;
	}

	// Mobt@NA
	BYTE RxdBuff[256];
	::ZeroMemory(RxdBuff, sizeof RxdBuff);

	// Mxݒ
	if(SendIoRequest(IOCODE_CONTROL, (BYTE *)SetLnbReq[bEnable ? 1 : 0], sizeof(SetLnbReq),
		RxdBuff, sizeof(SetLnbReq)) == -1)return false;

	return true;
}

const float CBonBlackTuner::GetSignalLevel(void)
{
	// Mxv
	static const BYTE abyGetLevReq[] = {0xC0, 0x02 ,0x00, 0x32, 0xBA, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	// `⊮ŋߎ
	static const float afLevelTable[] =
	{
		24.07f,	// 00	00	0		24.07dB
		24.07f,	// 10	00	4096	24.07dB
		18.61f,	// 20	00	8192	18.61dB
		15.21f,	// 30	00	12288	15.21dB
		12.50f,	// 40	00	16384	12.50dB
		10.19f,	// 50	00	20480	10.19dB
		8.140f,	// 60	00	24576	8.140dB
		6.270f,	// 70	00	28672	6.270dB
		4.550f,	// 80	00	32768	4.550dB
		3.730f,	// 88	00	34816	3.730dB
		3.630f,	// 88	FF	35071	3.630dB
		2.940f,	// 90	00	36864	2.940dB
		1.420f,	// A0	00	40960	1.420dB
		0.000f	// B0	00	45056	-0.01dB
	};

	// Mobt@NA
	BYTE RxdBuff[256];
	::ZeroMemory(RxdBuff, sizeof RxdBuff);

	// Mxv
	if(SendIoRequest(IOCODE_CONTROL, (BYTE *)abyGetLevReq, sizeof(abyGetLevReq), RxdBuff, sizeof(abyGetLevReq)) == -1)return 0.0f;

	// MxvZ
	if(RxdBuff[40] <= 0x10U){
		// őNbv
		return 24.07f;
	}
	else if(RxdBuff[40] >= 0xB0U){
		// ŏNbv
		return 0.0f;
	}
	else{
		// `⊮
		const float fMixRate = (float)(((WORD)(RxdBuff[40] & 0x0FU) << 8) | (WORD)RxdBuff[41]) / 4095.0f;
		return afLevelTable[RxdBuff[40] >> 4] * (1.0f - fMixRate) + afLevelTable[(RxdBuff[40] >> 4) + 0x01U] * fMixRate;
	}
}

CBonBlackTuner::CBonBlackTuner(IBonObject *pOwner)
	: CBonTunerBase(pOwner, IDR_INISEQ_BLACK, IDR_ENDSEQ_BLACK)
{

}
