// BonTunerBase.cpp: Friio`[i[NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Resource.h"
#include "BonSDK.h"
#include "BonTunerBase.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// obt@ݒ
#define ASYNCBUFFTIME		2UL											// obt@ = 2b
#define ASYNCBUFFNUM		(0x400000UL / TSRECVSIZE * ASYNCBUFFTIME)	// 32MbpsƂ

#define REQRESERVNUM		16UL			// 񓯊NGXg\

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020UL	// `[iRg[
#define IOCODE_STREAM		0x0022004BUL	// Xg[NGXg

#define ENABLE_LNB_REGKEY	TEXT("Software\\BonSDK\\FriioDriver")
#define ENABLE_LNB_REGNAME	TEXT("EnableLnbFunction")
#define ENABLE_LNB_REGVALUE	1


/////////////////////////////////////////////////////////////////////////////
// Friiop@TS`[i HALC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

// I/ONGXgL[f[^
class CBonTunerBase::ASYNC_REQ_DATA
{
private:
	CSmartEvent *m_pEvent;

	ASYNC_REQ_DATA(const ASYNC_REQ_DATA &);
	void operator =(const ASYNC_REQ_DATA &);

public:
	OVERLAPPED OverLapped;
	DWORD dwRxdSize;
	BYTE TxdBuff[64];
	BYTE RxdBuff[TSRECVSIZE];

	ASYNC_REQ_DATA()
		: m_pEvent(0), dwRxdSize(0)
	{
		::ZeroMemory(&OverLapped, sizeof OverLapped);
		::ZeroMemory(TxdBuff, sizeof TxdBuff);
		::ZeroMemory(RxdBuff, sizeof RxdBuff);
	}

	~ASYNC_REQ_DATA()
	{
		Close();
	}

	void Initialize(const BYTE *pTxdData, DWORD size)
	{
		Close();

		m_pEvent = new CSmartEvent(true);

		::ZeroMemory(&OverLapped, sizeof OverLapped);
		OverLapped.hEvent = m_pEvent->UnsafeGetHandle();

		::ZeroMemory(TxdBuff, sizeof TxdBuff);
		::CopyMemory(TxdBuff, pTxdData, size);

		::ZeroMemory(RxdBuff, sizeof RxdBuff);

		dwRxdSize = 0;
	}

	const IKernelObject *GetKernelObject() const
	{
		return m_pEvent;
	}

	void Close()
	{
		if (m_pEvent != 0)
		{
			delete m_pEvent;
			m_pEvent = 0;
		}
	}
};

HINSTANCE CBonTunerBase::m_hModule = NULL;

const BONGUID CBonTunerBase::GetDeviceType(void)
{
	// foCX̃^CvԂ
	return ::BON_NAME_TO_GUID(TEXT("IHalTsTuner"));
}

const DWORD CBonTunerBase::GetTotalDeviceNum(void)
{
	// FriiȏԂ
	return (m_BonEnumerator.EnumDevice(true))? m_BonEnumerator.GetTotalNum() : 0UL;
}

const DWORD CBonTunerBase::GetActiveDeviceNum(void)
{
	// gpFriio̐Ԃ
	return (m_BonEnumerator.EnumDevice(true))? m_BonEnumerator.GetActiveNum() : 0UL;
}

const bool CBonTunerBase::OpenTuner(void)
{
	// UN[Y
	CloseTuner();

	try
	{
		if(!OnOpenTuner()) throw __LINE__;

		// gp̃`[i擾
		LPCTSTR lpszDriverPath = m_BonEnumerator.GetAvailableDriverPath();
		if(!lpszDriverPath) throw __LINE__;

		// hCoI[v
		if((m_hFriioDriver = ::CreateFile(lpszDriverPath,
			GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE,
			NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL)) ==
			INVALID_HANDLE_VALUE) throw __LINE__;

		// hCobN
		if(!m_BonEnumerator.LockDevice(lpszDriverPath)) throw __LINE__;

		// XbhN
		if(!m_IoReqThread.StartThread(this, &CBonTunerBase::IoReqThread)) throw __LINE__;
	}
	catch (...)
	{
		// G[
		CloseTuner();
		return false;
	}

	return true;
}

void CBonTunerBase::CloseTuner(void)
{
	// Xbh~
	m_IoReqThread.EndThread();

	if(m_hFriioDriver != INVALID_HANDLE_VALUE)
	{
		// hCoN[Y
		::CloseHandle(m_hFriioDriver);
		m_hFriioDriver = INVALID_HANDLE_VALUE;
	}

	// hCobNJ
	m_BonEnumerator.ReleaseDevice();

	// `l
	m_dwCurSpace = 0UL;
	m_dwCurChannel = 0UL;
}

const DWORD CBonTunerBase::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CBonTunerBase::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

const bool CBonTunerBase::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// `[jO͈̓`FbN
	if (!EnumChannelName(dwSpace, dwChannel, NULL)) return false;

	if (!OnSetChannel(dwSpace, dwChannel)) return false;

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	// Xg[p[W
	PurgeStream();

	return true;
}

const bool CBonTunerBase::SetLnbPower(const bool bEnable)
{
	return false;
}

const bool CBonTunerBase::GetStream(BYTE **ppStream, DWORD *pdwSize, DWORD *pdwRemain)
{
	CBlockLock AutoLock(&m_AsyncQueueLock);

	// `[iI[vĂȂ
	if (m_hFriioDriver == INVALID_HANDLE_VALUE) return false;

	// ML[珈σf[^o
	if (m_AsyncRecvQue.size() == 0)
	{
		// o\ȃf[^Ȃ
		if(ppStream)*ppStream = NULL;
		if(pdwSize)*pdwSize = 0UL;
		if(pdwRemain)*pdwRemain = 0UL;

		return true;
	}

	// f[^o
	ASYNC_REQ_DATA *pAsyncReq = m_AsyncRecvQue.front();

	if(pdwRemain)*pdwRemain = m_AsyncRecvQue.size();
	if(ppStream)*ppStream = pAsyncReq->RxdBuff;
	if(pdwSize)*pdwSize = pAsyncReq->OverLapped.InternalHigh;

	m_AsyncRecvQue.pop();
	if (m_AsyncRecvQue.size() == 0)
	{
		m_TsRecvEvent.ResetEvent();
	}

	return true;
}

void CBonTunerBase::PurgeStream(void)
{
	CBlockLock lock(&m_AsyncQueueLock);

	// ML[J
	while (m_AsyncRecvQue.size() > 0)
	{
		m_AsyncRecvQue.pop();
	}
}

const IKernelObject &CBonTunerBase::GetStreamEvent() const
{
	// Xg[EFCg
	return m_TsRecvEvent;
}

const DWORD CBonTunerBase::GetAvailableNum(void)
{
	CBlockLock lock(&m_AsyncQueueLock);

	// o\Xg[Ԃ
	return m_AsyncRecvQue.size();
}

CBonTunerBase::CBonTunerBase(IBonObject *pOwner, int initSeqID, int endSeqID)
	: CBonObject(pOwner)
	, m_hFriioDriver(NULL)
	, m_dwCurSpace(0UL)
	, m_dwCurChannel(0UL)
	, m_TsRecvEvent(true)
	, m_dwBufferSize(0)
	, m_dwBufferPosition(0)
	, m_pAsyncBuffer(0)
	, m_initSeqID(initSeqID)
	, m_endSeqID(endSeqID)
{

}

CBonTunerBase::~CBonTunerBase(void)
{
	CloseTuner();
}

const int CBonTunerBase::SendIoRequest(const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if (m_hFriioDriver == INVALID_HANDLE_VALUE) return -1;

	// Mpf[^ݒ
	OVERLAPPED OverLapped;
	::ZeroMemory(&OverLapped, sizeof(OverLapped));
	CSmartEvent event(true);
	OverLapped.hEvent = event.UnsafeGetHandle();

	// f[^M
	DWORD dwReturned = 0UL;
	const BOOL bReturn = ::DeviceIoControl(m_hFriioDriver, dwIoCode, const_cast<BYTE *>(pTxdData), dwTxdSize, pRxdData, dwRxdSize, &dwReturned, &OverLapped);

	// G[AMf[^擾
	if (!bReturn)
	{
		if (::GetLastError() != ERROR_IO_PENDING) return -1;
		if (!::GetOverlappedResult(m_hFriioDriver, &OverLapped, &dwReturned, TRUE)) return -1;
	}

	return (int)dwReturned;
}

void CBonTunerBase::SetModuleHandle(const HINSTANCE hModule)
{
	// W[nho^
	m_hModule = hModule;
}

const HINSTANCE CBonTunerBase::GetModuleInstance()
{
	return m_hModule;
}

const bool CBonTunerBase::SendFixedRequest(const UINT nID)
{
	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(m_hModule, MAKEINTRESOURCE(nID), TEXT("BINARY"));
	if(!hRsrc)return false;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(m_hModule, hRsrc);
	if(!hGlobal)return false;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return false;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(m_hModule, hRsrc);

	// \[Xf[^𑗐M
	DWORD dwXmited = 0UL;
	FIXED_REQ_HEAD *pFixedReqHead;

	while (dwXmited < dwIoReqSize)
	{
		// Rg[擾
		pFixedReqHead = (FIXED_REQ_HEAD *)pFixedBuff;
		pFixedBuff += sizeof(FIXED_REQ_HEAD);

		// Mobt@NA
		BYTE RxdBuff[256];
		::ZeroMemory(RxdBuff, sizeof RxdBuff);

		// f[^M
		if (SendIoRequest(pFixedReqHead->dwIoCode, pFixedBuff, pFixedReqHead->wTxdSize, RxdBuff, pFixedReqHead->wRxdSize) == -1) return false;
		pFixedBuff += pFixedReqHead->wTxdSize;

		// MσTCYXV
		dwXmited += (sizeof(FIXED_REQ_HEAD) + pFixedReqHead->wTxdSize);
	}

	return true;
}

const bool CBonTunerBase::AllocateBuffer(const DWORD dwBufferNum)
{
	CBlockLock lock(&m_AsyncQueueLock);

	ReleaseBuffer();

	m_dwBufferSize = max(dwBufferNum, REQRESERVNUM);
	m_dwBufferPosition = 0;
	m_pAsyncBuffer = new ASYNC_REQ_DATA[m_dwBufferSize];

	return true;
}

void CBonTunerBase::ReleaseBuffer(void)
{
	CBlockLock lock(&m_AsyncQueueLock);

	// NGXgL[J
	while (m_AsyncReqQue.size() > 0)
	{
		m_AsyncReqQue.pop();
	}

	// ML[J
	while (m_AsyncRecvQue.size() > 0)
	{
		m_AsyncRecvQue.pop();
	}

	if (m_pAsyncBuffer != 0)
	{
		delete [] m_pAsyncBuffer;
		m_pAsyncBuffer = 0;
		m_dwBufferSize = 0;
		m_dwBufferPosition = 0;
	}
}

void CBonTunerBase::IoReqThread(CSmartThread<CBonTunerBase> &thread, const ISignal &bKillSignal, PVOID pParam)
{
	// V[PXM
	SendFixedRequest(m_initSeqID);

	// ftHg`lݒ
	SetChannel(0UL, 0UL);

	// CxgZbg
	m_TsRecvEvent.ResetEvent();

	// obt@m
	AllocateBuffer(ASYNCBUFFNUM + REQRESERVNUM);

	try
	{
		// hCoɃXg[NGXg𔭍s
		while (true)
		{
			// hCoTSf[^NGXg𔭍s
			PushIoRequest();

			// σf[^΃NGXg
			if (PopIoRequest(bKillSignal) == false)
			{
				break;
			}
		}
	}
	catch (...)
	{
	}

	// IV[PXM
	SendFixedRequest(m_endSeqID);

	// ׂĂ̔񓯊I/OLZ
	// 񓯊I/ÕLŹAfoCXɂsȂB
	// ܂A񓯊I/O𔭍sXbhłpȂB
	// ifriioĂAǂɂĂLZ͏oȂj
	::CancelIo(m_hFriioDriver);

	// obt@J
	ReleaseBuffer();

	// CxgZbg(ҋ@XbhJ)
	m_TsRecvEvent.SetEvent();
}

const bool CBonTunerBase::PushIoRequest(void)
{
	// Xg[NGXg
	static const BYTE abyStreamReq[]  = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	// NGXg҂KɒB܂ŌJԂ
	while (m_AsyncReqQue.size() < REQRESERVNUM)
	{
		// NGXgݒ
		ASYNC_REQ_DATA *pAsyncReq = m_pAsyncBuffer + m_dwBufferPosition;
		pAsyncReq->Initialize(abyStreamReq, sizeof abyStreamReq);

		// NGXgs
		if (!::DeviceIoControl(m_hFriioDriver, IOCODE_STREAM,
			pAsyncReq->TxdBuff, sizeof abyStreamReq,
			pAsyncReq->RxdBuff, sizeof pAsyncReq->RxdBuff,
			NULL, &pAsyncReq->OverLapped))
		{
			if (::GetLastError() != ERROR_IO_PENDING)
			{
				break;
			}
		}

		// L[ɓ
		m_AsyncReqQue.push(pAsyncReq);
		m_dwBufferPosition++;
		if (m_dwBufferPosition >= m_dwBufferSize)
		{
			m_dwBufferPosition = 0;
		}
	}

	return true;
}

const bool CBonTunerBase::PopIoRequest(const ISignal &bKillSignal)
{
	if (m_AsyncReqQue.size() == 0)
	{
		return true;
	}
	ASYNC_REQ_DATA *pAsyncReq = m_AsyncReqQue.front();

	// Cxg҂
	IWaitableObject::WaitResult result = (*bKillSignal.GetKernelObject() || *pAsyncReq->GetKernelObject()).Wait();
	if (result != IWaitableObject::Signal1)
	{
		return false;
	}

	if (m_AsyncReqQue.size() == 0)
	{
		return true;
	}

	m_AsyncReqQue.pop();

	// G[
	if (!::GetOverlappedResult(m_hFriioDriver, &pAsyncReq->OverLapped, &pAsyncReq->dwRxdSize, FALSE))
	{
		return true;
	}

	// CxgnhN[Y
	pAsyncReq->Close();

	CBlockLock lock(&m_AsyncQueueLock);

	// ML[ɒǉ
	m_AsyncRecvQue.push(pAsyncReq);

	// O̎ML[Ȃ
	if (m_AsyncRecvQue.size() == 1)
	{
		// Xg[CxgZbg
		m_TsRecvEvent.SetEvent();
	}

	return true;
}
