// BonTunerBase.h: Friio`[i[NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <Vector>
#include <Queue>
#include "BonEnumerator.h"


/////////////////////////////////////////////////////////////////////////////
// Friiop@TS`[i HALC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

#define TSRECVSIZE 48128UL			// TSf[^MTCY

class CBonTunerBase :	public CBonObject,
						public IHalDevice,
						public IHalTsTuner
{
public:
// IHalDevice
	virtual const BONGUID GetDeviceType(void);
	virtual const DWORD GetDeviceName(LPTSTR lpszName) = 0;
	virtual const DWORD GetTotalDeviceNum(void);
	virtual const DWORD GetActiveDeviceNum(void);

// IHalTsTuner
	virtual const bool OpenTuner(void);
	virtual void CloseTuner(void);
	
	virtual const DWORD EnumTuningSpace(const DWORD dwSpace, LPTSTR lpszSpace) = 0;
	virtual const DWORD EnumChannelName(const DWORD dwSpace, const DWORD dwChannel, LPTSTR lpszChannel) = 0;
	
	virtual const DWORD GetCurSpace(void);
	virtual const DWORD GetCurChannel(void);

	virtual const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	virtual const bool SetLnbPower(const bool bEnable);
	virtual const float GetSignalLevel(void) = 0;

	virtual const bool GetStream(BYTE **ppStream, DWORD *pdwSize, DWORD *pdwRemain);

	virtual void PurgeStream(void);
	virtual const IKernelObject &GetStreamEvent() const;
	virtual const DWORD GetAvailableNum(void);

	virtual ~CBonTunerBase(void);
		
	static void SetModuleHandle(const HINSTANCE hModule);

protected:
// CBonTunerBase
	CBonTunerBase(IBonObject *pOwner, int initSeqID, int endSeqID);

	virtual const bool OnOpenTuner(void) = 0;
	virtual const bool OnSetChannel(const DWORD dwSpace, const DWORD dwChannel) = 0;

	const int SendIoRequest(const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize);
	const bool SendFixedRequest(const UINT nID);
	static const HINSTANCE GetModuleInstance();

	// ŒI/ONGXgwb_
	#pragma pack(1)
	struct FIXED_REQ_HEAD
	{
		DWORD dwIoCode;		// I/ORg[R[h
		WORD wTxdSize;		// Mf[^TCY
		WORD wRxdSize;		// Mf[^TCY
	};
	#pragma pack()

	CBonEnumerator m_BonEnumerator;

private:
	const bool AllocateBuffer(const DWORD dwBufferNum);
	void ReleaseBuffer(void);

	void IoReqThread(CSmartThread<CBonTunerBase> &thread, const ISignal &bKillSignal, PVOID pParam);

	const bool PushIoRequest(void);
	const bool PopIoRequest(const ISignal &bKillSignal);

	// I/ONGXgL[f[^
	class ASYNC_REQ_DATA;

	HANDLE m_hFriioDriver;

	DWORD m_dwBufferSize;
	DWORD m_dwBufferPosition;
	ASYNC_REQ_DATA *m_pAsyncBuffer;
	std::queue<ASYNC_REQ_DATA *> m_AsyncReqQue;
	std::queue<ASYNC_REQ_DATA *> m_AsyncRecvQue;
	
	CSmartThread<CBonTunerBase> m_IoReqThread;
	
	CSmartLock m_AsyncQueueLock;
	CSmartEvent m_TsRecvEvent;
	
	DWORD m_dwCurSpace;
	DWORD m_dwCurChannel;

	const int m_initSeqID;
	const int m_endSeqID;

	static HINSTANCE m_hModule;
};
