// ProgAnalyzer.cpp: vOAiCUfR[_
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsTable.h"
#include "ProgAnalyzer.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// vOAiCUfR[_
/////////////////////////////////////////////////////////////////////////////

const bool CProgAnalyzer::InputMedia(IMediaData *pMediaData, const DWORD dwInputIndex)
{
	// ̓p[^`FbN
	ITsPacket * const pTspacket = dynamic_cast<ITsPacket *>(pMediaData);
	if(!pTspacket || (dwInputIndex >= GetInputNum()))return false;

	// PID}bvɓ
	m_TsPidMapper.StorePacket(pTspacket);

	// ʃfR[_Ƀf[^o
	OutputMedia(pMediaData);

	return true;
}

const WORD CProgAnalyzer::GetNetworkID(void)
{
	// IWilbg[NIDԂ
	return m_ProgContext.wNetworkID;
}

const WORD CProgAnalyzer::GetTsID(void)
{
	// TS IDԂ
	return m_ProgContext.wTsID;
}

const DWORD CProgAnalyzer::GetProgramNum(void)
{
	// LȃvOԂ
	DWORD dwNum = 0UL;
	
	for(ProgramList::iterator itProgram = m_ProgContext.ProgList.begin() ; itProgram != m_ProgContext.ProgList.end() ; itProgram++){
		if(itProgram->bAvailable)dwNum++;
		}
		
	return dwNum;
}

const WORD CProgAnalyzer::GetProgramID(const DWORD dwIndex)
{
	// vOIDԂ
	DWORD dwPos = 0UL;
	
	for(ProgramList::iterator itProgram = m_ProgContext.ProgList.begin() ; itProgram != m_ProgContext.ProgList.end() ; itProgram++){
		if(itProgram->bAvailable){
			if(dwPos++ == dwIndex)return itProgram->wProgramID;
			}
		}
		
	return 0x0000U;
}

const WORD CProgAnalyzer::GetProgramVideoPID(const WORD wProgramID)
{
	// fPIDԂ
	const PROGRAM_ITEM * pItem = FindProgramItem(wProgramID);
	return (pItem)? pItem->wVideoPID : TS_INVALID_PID;
}

const WORD CProgAnalyzer::GetProgramAudioPID(const WORD wProgramID)
{
	// PIDԂ
	const PROGRAM_ITEM * pItem = FindProgramItem(wProgramID);
	return (pItem)? pItem->wAudioPID : TS_INVALID_PID;
}

const WORD CProgAnalyzer::GetProgramPcrPID(const WORD wProgramID)
{
	// PCRPIDԂ
	const PROGRAM_ITEM * pItem = FindProgramItem(wProgramID);
	return (pItem)? pItem->wPcrPID : TS_INVALID_PID;
}

const DWORD CProgAnalyzer::GetNetworkName(LPTSTR lpszNetworkName)
{
	// lbg[NԂ
	if(lpszNetworkName)::_tcscpy(lpszNetworkName, m_ProgContext.szNetworkName);

	// obt@ɕKvȕԂ
	return ::_tcslen(m_ProgContext.szNetworkName);
}

const DWORD CProgAnalyzer::GetServiceName(LPTSTR lpszServiceName, const WORD wProgramID)
{
	// T[rXԂ
	const PROGRAM_ITEM * pItem = FindProgramItem(wProgramID);
	if(!pItem)return 0UL;
	
	// obt@ɃRs[
	if(lpszServiceName)::_tcscpy(lpszServiceName, pItem->szServiceName);

	// obt@ɕKvȕԂ
	return ::_tcslen(pItem->szServiceName);
}

const bool CProgAnalyzer::GetStreamTime(SYSTEMTIME *pStreamTime)
{
	// Xg[̎ԂԂ
	ITotTable *pTotTable = dynamic_cast<ITotTable *>(m_TsPidMapper.GetMapTarget(0x0014U));
	::BON_ASSERT(pTotTable != NULL);
	
	CTsTime StreamTime = pTotTable->GetDateTime();
	if(StreamTime.IsEmpty())return false;

	// ԂZbg	
	if(pStreamTime)*pStreamTime = StreamTime;
	
	return true;
}

const WORD CProgAnalyzer::GetCurrentProgramID(void)
{
	// ݂̃vOIDԂ
	return m_ProgContext.wCurProgramID;
}

const bool CProgAnalyzer::SetCurrentProgramID(const WORD wProgramID)
{
	// ݂̃vOIDݒ肷
	if(wProgramID){
		// wvOIDɕύX
		if(FindProgramItem(wProgramID))return false;
		m_ProgContext.wCurProgramID = wProgramID;
		}
	else{
		// ftHgvOIDɕύX(PAT̍ŏ̃vOID)
		if(!m_ProgContext.ProgList.size())return false;
		m_ProgContext.wCurProgramID = m_ProgContext.ProgList[0].wProgramID;
		}

	return true;
}

const IEpgItem * CProgAnalyzer::GetCurrentEpgInfo(const WORD wProgramID)
{
	// ݂EPGԂ
	const PROGRAM_ITEM * pItem = FindProgramItem(wProgramID);
	return (pItem)? pItem->pCurEpgItem : NULL;
}

const IEpgItem * CProgAnalyzer::GetNextEpgInfo(const WORD wProgramID)
{
	// EPGԂ
	const PROGRAM_ITEM * pItem = FindProgramItem(wProgramID);
	return (pItem)? pItem->pNextEpgItem : NULL;
}

CProgAnalyzer::CProgAnalyzer(IBonObject *pOwner)
	: CMediaDecoder(pOwner, 1UL, 1UL)
	, m_TsPidMapper(NULL)
{
	// PATe[uPID}bvɒǉ
	m_TsPidMapper.MapPid(0x0000U, dynamic_cast<ITsPidMapTarget *>(CPatTable::CreateInstance(dynamic_cast<IPatTable::IHandler *>(this))));

	// NITe[uPID}bvɒǉ
	m_TsPidMapper.MapPid(0x0010U, dynamic_cast<ITsPidMapTarget *>(CNitTable::CreateInstance(dynamic_cast<INitTable::IHandler *>(this))));

	// SDTe[uPID}bvɒǉ
	m_TsPidMapper.MapPid(0x0011U, dynamic_cast<ITsPidMapTarget *>(CSdtTable::CreateInstance(dynamic_cast<ISdtTable::IHandler *>(this))));

	// EITe[uPID}bvɒǉ
	m_TsPidMapper.MapPid(0x0012U, dynamic_cast<ITsPidMapTarget *>(CEitTable::CreateInstance(dynamic_cast<IEitTable::IHandler *>(this))));

	// TOTe[uPID}bvɒǉ
	m_TsPidMapper.MapPid(0x0014U, dynamic_cast<ITsPidMapTarget *>(CTotTable::CreateInstance(dynamic_cast<ITotTable::IHandler *>(this))));

	// ԃZbg
	OnReset();
}

CProgAnalyzer::~CProgAnalyzer(void)
{
	// CX^XJ
	for(ProgramList::iterator itProgram = m_ProgContext.ProgList.begin() ; itProgram != m_ProgContext.ProgList.end() ; itProgram++){
		BON_SAFE_RELEASE(itProgram->pCurEpgItem);
		BON_SAFE_RELEASE(itProgram->pNextEpgItem);
		}
}

const bool CProgAnalyzer::OnPlay(void)
{
	return OnReset();
}

const bool CProgAnalyzer::OnReset(void)
{
	// ReLXgZbg
	m_ProgContext.wNetworkID = 0x0000U;
	m_ProgContext.wTsID = 0x0000U;
	m_ProgContext.wCurProgramID = 0x0000U;
	m_ProgContext.szNetworkName[0] = TEXT('\0');

	for(ProgramList::iterator itProgram = m_ProgContext.ProgList.begin() ; itProgram != m_ProgContext.ProgList.end() ; itProgram++){
		BON_SAFE_RELEASE(itProgram->pCurEpgItem);
		BON_SAFE_RELEASE(itProgram->pNextEpgItem);
		}

	m_ProgContext.ProgList.clear();

	// PID}bvZbg
	ResetPidMap();

	// PATZbg
	m_TsPidMapper.ResetPid(0x0000U);

	return true;
}

void CProgAnalyzer::OnPatTable(const IPatTable *pPatTable)
{
	// TS ID̕ω`FbN
	if(m_ProgContext.wTsID != pPatTable->GetTsID()){
		// TS IDωƂ͏ԂZbg
		ResetPidMap();
		m_ProgContext.wTsID = pPatTable->GetTsID();
		}

	// PMTe[u}bv
	for(DWORD dwIndex = 0UL ; dwIndex < pPatTable->GetProgramNum() ; dwIndex++){
		m_TsPidMapper.MapPid(pPatTable->GetPmtPID(dwIndex), dynamic_cast<ITsPidMapTarget *>(CPmtTable::CreateInstance(dynamic_cast<IPmtTable::IHandler *>(this))));
		}

	// ݂ȂvOID폜
	for(ProgramList::iterator itProgram = m_ProgContext.ProgList.begin() ; itProgram != m_ProgContext.ProgList.end() ; ){

		// PAT
		bool bFound = false;
	
		for(DWORD dwIndex = 0UL ; (dwIndex < pPatTable->GetProgramNum()) && !bFound; dwIndex++){
			if(itProgram->wProgramID == pPatTable->GetProgramID(dwIndex)){
				bFound = true;
				}			
			}

		if(!bFound){
			// vOXg폜
			BON_SAFE_RELEASE(itProgram->pCurEpgItem);
			BON_SAFE_RELEASE(itProgram->pNextEpgItem);

			m_ProgContext.ProgList.erase(itProgram);
			itProgram = m_ProgContext.ProgList.begin();
			}
		else{
			itProgram++;
			}
		}

	// VK̃vOIDǉ
	for(DWORD dwIndex = 0UL ; dwIndex < pPatTable->GetProgramNum() ; dwIndex++){
		if(FindProgramItem(pPatTable->GetProgramID(dwIndex)))continue;

		// vOIDɂȂ悤ɑ}
		ProgramList::iterator itProgram = m_ProgContext.ProgList.begin();

		for( ; itProgram != m_ProgContext.ProgList.end() ; itProgram++){
			if(itProgram->wProgramID > pPatTable->GetProgramID(dwIndex))break;
			}
		
		const PROGRAM_ITEM NewItem =
		{
			false,														// bAvailable
			pPatTable->GetProgramID(dwIndex),							// wProgramID
			TS_INVALID_PID,												// wVideoPID
			TS_INVALID_PID,												// wAudioPID
			TS_INVALID_PID,												// wPcrPID
			TEXT(""),													// szServiceName[]
			dynamic_cast<IEpgItem *>(CEpgItem::CreateInstance(NULL)),	// pCurEpgItem
			dynamic_cast<IEpgItem *>(CEpgItem::CreateInstance(NULL))	// pNextEpgItem
		};

		m_ProgContext.ProgList.insert(itProgram, NewItem);
		}

	// ݂̃vOID̕ύX𔻒肷
	if(!FindProgramItem(m_ProgContext.wCurProgramID)){
		// VK̃vOIDɕύX
		m_ProgContext.wCurProgramID = (m_ProgContext.ProgList.size())? m_ProgContext.ProgList[0].wProgramID : 0x0000U;
		}
}

void CProgAnalyzer::OnPmtTable(const IPmtTable *pPmtTable)
{
	// vOXV
	PROGRAM_ITEM *pProgItem = FindProgramItem(pPmtTable->GetProgramID());
	if(!pProgItem)return;

	// PCRPIDXV
	pProgItem->wPcrPID = pPmtTable->GetPcrPID();

	// f/PIDXV
	for(DWORD dwIndex = 0UL ; dwIndex < pPmtTable->GetEsNum() ; dwIndex++){
		switch(pPmtTable->GetStreamTypeID(dwIndex)){
			case 0x02U :	// ITU-TH.262|ISO/IEC 13818-2f
				pProgItem->wVideoPID = pPmtTable->GetEsPID(dwIndex);
				break;
				
			case 0x0FU :	// ISO/IEC 13818-7iADTSgX|[g\j
				pProgItem->wAudioPID = pPmtTable->GetEsPID(dwIndex);
				break;
			}
		}

	// LtOXV
	if((pProgItem->wVideoPID != TS_INVALID_PID) && (pProgItem->wAudioPID != TS_INVALID_PID)){
		// MPEG2fAACvOLƂ
		pProgItem->bAvailable = true;
		}
}

void CProgAnalyzer::OnNitTable(const INitTable *pNitTable)
{
	// lbg[NIDXV
	m_ProgContext.wNetworkID = pNitTable->GetNetworkID();

	// lbg[NXV
	const INetworkNameDesc *pNetworkNameDesc = dynamic_cast<const INetworkNameDesc *>(pNitTable->GetNetworkDesc()->GetDescByTag(INetworkNameDesc::DESC_TAG));
	if(pNetworkNameDesc)pNetworkNameDesc->GetNetworkName(m_ProgContext.szNetworkName);
}

void CProgAnalyzer::OnSdtTable(const ISdtTable *pSdtTable)
{
	// T[rXXV
	for(DWORD dwIndex = 0UL ; dwIndex < pSdtTable->GetServiceNum() ; dwIndex++){
		const WORD wServiceID = pSdtTable->GetServiceID(dwIndex);
		PROGRAM_ITEM *pProgItem = FindProgramItem(wServiceID);
		if(!pProgItem)continue;

		// T[rXXV	
		const IServiceDesc *pServiceDesc = dynamic_cast<const IServiceDesc *>(pSdtTable->GetServiceDesc(wServiceID)->GetDescByTag(IServiceDesc::DESC_TAG));
		if(!pServiceDesc)continue;

		pServiceDesc->GetServiceName(pProgItem->szServiceName);
		}
}

void CProgAnalyzer::OnTotTable(const ITotTable *pTotTable)
{
	// Ȃ
}

void CProgAnalyzer::OnEitTable(const IEitTable *pEitTable, const IEitItem *pEitItem)
{
	// EPGXV
	if(pEitTable->GetOrgNetworkID() != GetNetworkID())return;
	if(pEitTable->GetTsID() != GetTsID())return;
	
	PROGRAM_ITEM *pProgItem = FindProgramItem(pEitTable->GetServiceID());
	if(!pProgItem)return;

	if(pEitTable->GetTableID() == IEitTable::TABLE_ID_CURORNEXT_SELF){
		//  or EPGXgA
		switch(pEitTable->GetSectionNumber()){
			case 0U :
				if(pProgItem->pCurEpgItem->StoreEitItem(pEitItem)){
					// ԑgXVCxg
//					TCHAR szInfo[4096] = TEXT("M");
//					pProgItem->pCurEpgItem->GetEventDetail(szInfo);
//					::BON_TRACE(TEXT("Info: %04X\n%s\n\n"), pProgItem->pCurEpgItem->GetEventID(), szInfo);
					}
				break;

			case 1U :
				if(pProgItem->pNextEpgItem->StoreEitItem(pEitItem)){
					// ԑgXVCxg
					}
				break; 

			default :
				// Ki͂肦Ȃ
				break;
			}
		}
	else{
		// XPW[ςEPGXgA
		}	
}

void CProgAnalyzer::ResetPidMap(void)
{
	// NIT/SDT/TOTZbgAȊO̓A}bv
	for(WORD wPID = 0x0000U ; wPID < 0x2000U ; wPID++){
		switch(wPID){
			case 0x0000 :	// PAT
				break;
			
			case 0x0010 :	// NIT
			case 0x0011 :	// SDT
			case 0x0012 :	// EIT
			case 0x0014 :	// TOT
				// Zbg
				m_TsPidMapper.ResetPid(wPID);
				break;
			
			default :
				// A}bv
				m_TsPidMapper.UnmapPid(wPID);
				break;			
			}
		}
}

CProgAnalyzer::PROGRAM_ITEM * CProgAnalyzer::FindProgramItem(WORD wProgramID)
{
	// vOIDȗ݂͌̃vO
	if(!wProgramID)wProgramID = GetCurrentProgramID();

	// vOIDΉACeĕԂ
	for(ProgramList::iterator itProgram = m_ProgContext.ProgList.begin() ; itProgram != m_ProgContext.ProgList.end() ; itProgram++){
		if(itProgram->wProgramID == wProgramID){
			return &(*itProgram);
			}
		}

	return NULL;
}
